(function() {
    // 计算时间差
    function timeDiff(time){
        var diffdate = new Date().getTime() - time*1000;
        var days = Math.floor(diffdate/(24*3600*1000));
        var leave1 = diffdate%(24*3600*1000);   
        var hours = Math.floor(leave1/(3600*1000));  

        var leave2 = leave1%(3600*1000);
        var minutes = Math.floor(leave2/(60*1000));
        var leave3 = leave2%(60*1000);
        var seconds = Math.round(leave3/1000);
        return (days && days > 0) ? days + "天前" : (hours && hours > 0) ? hours + "小时前" : (minutes && minutes > 0) ? minutes + "分钟前" : "刚刚";
    }
    /*获取主题帖子详情*/
    function getForumThreadDetails(callback) {
        // 实现native交互，获取主题帖子详情数据，并转成JSON对象 JSON.parse("");collection
//        callback({"like":false,"follow":false,"recommend_add":10,"collection":false,"fid":37,"summary":"近近景近景","forumName":"交友","subject":"标题标题标题标题标题标题标题标题标题标题","heats":0,"attachments":[{"fileName":"重力系统源码.rar","createdOn":148212731, "fileSize":39771,"readPerm":0, "isImage":0, "width":544, "uid":1,"url":"http://www.apkbus.com/201104/23/08053623ql625n0rz6s3d5.rar"},{"fileName":"我的照片","createdOn":148212731, "fileSize":39771,"readPerm":0, "isImage":1, "width":544, "uid":1,"url":"http://www.apkbus.com/201104/23/08053623ql625n0rz6s3d5.rar"} ],"avatar":"http://182.92.158.79/utf8_x33/uc_server/avatar.php?uid=190&size=middle","authorId":190,"createdOn":1493968050,"message":"<p>华叔说饭好少是粉红色的护发素的就俯拾地芥开发就是大回复就是导航福建省的和副驾驶的和副驾驶的合富金生店和副驾驶的和副驾驶的护发素的继父回家合富金生店和服就是的复活节</p><a href='www.baidu.com'>数据的撒地方惊世毒妃健身房附近的</a><p><img src='http://img4.imgtn.bdimg.com/it/u=1893242521,2314552659&fm=26&gp=0.jpg'><img src='http://img1.imgtn.bdimg.com/it/u=235569342,2055818743&fm=26&gp=0.jpg'></p>","author":"dftd","views":0,"replies":0,"images":["http://download.bbssdk.mob.com/30b/edb/ae9315c46ca6da0c8ea79ef0c5.jpg","http://download.bbssdk.mob.com/71f/c0e/62f88e0a1c1a015609dfdac044.jpg","http://download.bbssdk.mob.com/8d9/296/28016253bd6267a26dd8712037.png","http://download.bbssdk.mob.com/c61/bea/ff264d56027130de3d9ed3124c.jpg","http://download.bbssdk.mob.com/c61/bea/ff264d56027130de3d9ed3124c.jpg","http://download.bbssdk.mob.com/30b/edb/ae9315c46ca6da0c8ea79ef0c5.jpg","http://download.bbssdk.mob.com/f9d/26a/a39c9ad2d0539e124e4740b557.jpg"],"tid":234});
    	var data = null;
        try {
            if (window.forumThread) {
                data = window.forumThread.getForumThreadDetails();
            } else {
                data = prompt("getForumThreadDetails");
            }
        } catch(err) {
        }
        callback(data);
    }

    /*
     * 获取主题帖子回帖列表
     * @param authorId {number} 需要筛选的用户id，默认0（不筛选）
     * */
    function getPosts(all,fid, tid, page, pageSize,authorId, callback) {
        // 实现native交互，获取主题帖子回帖列表数据，并转成JSON对象 JSON.parse("");
//        console.log(fid+"&&&"+tid+"&&&"+page+"&&&"+pageSize+"&&&"+authorId)
//       callback([
//        {"createdOn":1494235567,"message":"hdhddhdhhdj<br />\n<img src=\"http://download.bbssdk.mob.com/30b/edb/ae9315c46ca6da0c8ea79ef0c5.jpg\" border=\"0\" alt=\"\" /><br />哈哈哈哈哈","position":1,"author":"orange","deviceName":"MI 4LTE","pid":21290,"tid":3857,"avatar":"http://182.92.158.79/utf8_x33/uc_server/avatar.php?uid=223&size=middle","authorId":190, "prePost": [{"author": "小小","message": "牛逼","createdOn": 1492832131,"position": 3, "deviceName": "iPhone 6p"}]},
//        {"createdOn":1494235605,"message":"liangzhanh<br />\n<img src=\"http://download.bbssdk.mob.com/bb0/160/d3e8d4488e23d31b99eabddbf2.jpg\" border=\"0\" alt=\"\" /><br />\n<img src=\"http://download.bbssdk.mob.com/71f/c0e/62f88e0a1c1a015609dfdac044.jpg\" border=\"0\" alt=\"\" />","position":2,"author":"orange","deviceName":"MI 4LTE","pid":21291,"tid":3857,"avatar":"http://182.92.158.79/utf8_x33/uc_server/avatar.php?uid=223&size=middle","authorId":223, "prePost": [{"author": "小小","message": "牛逼","createdOn": 1492832131,"position": 2, "deviceName": "iPhone 6p"},{"author": "小小","message": "牛逼","createdOn": 1492832131,"position": 2, "deviceName": "iPhone 6p"}]},
//        {"pid": 6,"tid": 123,"author": "小巴","authorId": 2996,"avatar": "http://www.apkbus.com/uc_server/avatar.php?uid=2996","message": "厉害了我的哥","position": 3,"createdOn": 1492833331,"deviceName": "华为 P9", "prePost": [{"author": "小小","message": "牛逼","createdOn": 1492832131,"position": 3, "deviceName": "iPhone 6p"}]},
//        {"pid": 5,"tid": 123,"author": "小小","authorId": 2836,"avatar": "http://www.apkbus.com/uc_server/avatar.php?uid=2836","message": "<p>牛逼</p>","position": 4,"createdOn": 1492832131,"deviceName": "iPhone 6p", "prePost": []},
//        {"pid": 5,"tid": 123,"author": "小小","authorId": 2836,"avatar": "http://www.apkbus.com/uc_server/avatar.php?uid=2836","message": "<p>牛逼</p>","position": 5,"createdOn": 1492832131,"deviceName": "iPhone 6p", "prePost": []}
//        ]);
        try {
            if (window.forumThread) {
                var func = $mob.ext._bindCallbackFunc(callback)
                window.forumThread.getPosts(all,fid, tid, page, pageSize, authorId, func);
            } else {
                var map = {
                    all:all,
                    fid: fid,
                    tid: tid,
                    page: page,
                    authorId: authorId,
                    pageSize: pageSize,
                    callback: func
                };
                prompt("getPosts", JSON.stringify(map));
            }
        } catch(err) {
            console.log(err)
            callback(null);
        }
    }

    /*打开图片*/
    function openImage(imgList,index) {
        // 实现native交互，跳转打开图片的界面
        if (window.forumThread) {
            window.forumThread.openImage(imgList, index);
        } else {
            console.log(index)
            console.log(JSON.stringify(imgList, null,2))
            var map = {
                imageUrls: imgList,
                index: index
            };
            prompt("openImage", JSON.stringify(map));
        }
    }
    function openSingleImage(url,index) {
        // 实现native交互，跳转打开图片的界面
        if (window.forumThread) {
            window.forumThread.openSingleImage(url, index);
        } else {
            console.log(index)
            console.log(JSON.stringify(imgList, null,2))
            var map = {
                imageUrls: imgList,
                index: index
            };
            prompt("openImage", JSON.stringify(map));
        }
    }
    /*打开附件*/
    function openAttachment(attachment) {
        // 实现native交互，跳转打开附件的界面
        if (window.forumThread) {
            window.forumThread.openAttachment(JSON.stringify(attachment));
        } else {
            console.log(attachment);
            prompt("openAttachment", JSON.stringify(attachment));
        }
    }

    /* 跳转链接 */
    function openHref(href) {
        var fileType;
        var startIndex = href.lastIndexOf(".");
        if(startIndex != -1){
            fileType  = href.substring(startIndex+1, href.length).toLowerCase();
        }
        if(fileType !="apk"){
            if (window.forumThread) {
                window.forumThread.openHref(href);
            } else {
                var map = {
                    clickUrl: href,
                };
                prompt("openHref", JSON.stringify(map));
            }
        }
    }

	/* 获取图片集合地址和当前索引
    * 设置hideNav为true时不显示头
    */
    function getImageUrlsAndIndex(callback,hideNav) {
        // 由Native返回对象{imageUrls:[], index:0}
//        callback({imageUrls:["https://ss1.bdstatic.com/70cFuXSh_Q1YnxGkpoWK1HF6hhy/it/u=949197531,2432970866&fm=23&gp=0.jpg",
//        "https://ss1.bdstatic.com/70cFuXSh_Q1YnxGkpoWK1HF6hhy/it/u=1738350124,1182499903&fm=23&gp=0.jpg",
//        "https://ss1.bdstatic.com/70cFuXSh_Q1YnxGkpoWK1HF6hhy/it/u=1497794588,1167065085&fm=23&gp=0.jpg"
//        ], index:0});
//        if(hideNav){
//            $(".photo-browser .bar").hide();
//            $(".bar-nav~.content").css({"top": "0"});
//        }
        var data = null;
        if (window.forumImage) {
            data = JSON.parse(window.forumImage.getImageUrlsAndIndex());
        } else {
            data = JSON.parse(prompt("getImageUrlsAndIndex"));
        }
        callback(data);
        if (hideNav) {
            $(".photo-browser .bar").hide();
            $(".bar-nav~.content").css({"top": "0"});
        }
    }

    /*设置当前页面图片地址和index*/
    function setCurrentImageSrc(imgSrc, index) {
        if (window.forumImage) {
            window.forumImage.setCurrentImageSrc(imgSrc, index);
        } else {
            var map = {
                imageSrc: imgSrc,
                index: index
            };
            prompt("setCurrentImageSrc", JSON.stringify(map));
        }
    }

    /* 下载图片，iimgList为界面所有的img标签对应的图片链接 */
    function downloadImages(imgUrls) {
        // 由Native去实现下载图片，并通过showImage方法，将下载好的图片返回给h5进行显示
//        console.log(JSON.stringify(imgList, null,2))
//        showImage('5a79560af426f702bc8aa56896fde32e', 'http://download.bbssdk.mob.com/71f/c0e/62f88e0a1c1a015609dfdac044.jpg')
//        showImage('74cbe2be4c9f1e32e2cee3961fdb8032', 'http://download.bbssdk.mob.com/bb0/160/d3e8d4488e23d31b99eabddbf2.jpg')
//        showImage('e214d62568598cae227f834b30a693a3', 'http://img4.imgtn.bdimg.com/it/u=1893242521,2314552659&fm=26&gp=0.jpg')
        if (window.forumThread) {
            window.forumThread.downloadImages(imgUrls);
        } else if (window.forumImage) {
            window.forumImage.downloadImages(imgUrls);
        } else {
            var map = {
                imageUrls: imgUrls,
            };
            prompt("downloadImages", JSON.stringify(map));
        }
    }

//    /* 显示图片，替换imgUrl对应的img标签的src值为imgSrc，其中imgSrc为Native已经下载好的本地图片地址 */
//    function showImage(imgUrlMD5, imgSrc) {
//        console.log("showImage1 md5 = " + imgUrlMD5 + ", src = " + imgSrc);
//        //H5实现此方法，并进行图片替换操作
//    	if (imgSrc) {
//    		$("."+imgUrlMD5).attr("src",imgSrc)
//			$("."+imgUrlMD5).attr("src_flag",'1')
//    	} else{
//    		$("."+imgUrlMD5).attr("src",'../assets/images/default_pic_error.png')
//    	}
//    }

    function showImage(index, imgUrlMD5, imgSrc, isImageViewer) {
    if (isImageViewer) {
        if (imgSrc) {
            $(".photo-browser .photo-browser-swiper-container .swiper-slide").eq(index).find("img").attr("src", imgSrc);
        } else {
            $(".photo-browser .photo-browser-swiper-container .swiper-slide").eq(index).find("img").attr("src", "img/default_pic_error.png");
        }
    } else {
       if (imgSrc) {
            $("."+imgUrlMD5).attr("src",imgSrc)
            $("."+imgUrlMD5).attr("src_flag",'1')
       } else{
            $("."+imgUrlMD5).attr("src",'../images/follow-no1.png')
       }
    }
//        if (isImageViewer) {
//
//        } else {
//            $.each($("[dz-imgshow]"), function(index, item){
//                if (item.src_link == imgUrlMD5) {
//                    if (imgSrc) {
//                        item.src = imgSrc;
//                    } else {
//                        item.src = "img/default_pic_error.png";
//                    }
//                }
//            });
//        }
    }

    /*
     * 添加新的评论
     * @param data {Object} 评论内容
     * @param authorId {number} 楼主编号
     * */
    function addNewCommentHtml(data, authorId){
        if(window.forumThread) {
            details.article.replies++
            details.commentList.push(data)//将data插入即可
        } else {
//            var data = {"pid": 5,"tid": 123,"author": "小小","authorId": 2836,"avatar": "http://www.apkbus.com/uc_server/avatar.php?uid=2836","message": "<p>牛逼</p>","position":6,"createdOn": 1492832131,"deviceName": "iPhone 6p", "prePost": []};
//            details.article.replies++
//            details.commentList.push(data)//将data插入即可
        }
    }

    /*
     * 回复方法
     * @param prepost {Object} 回复内容
    */
    function replyComment(prepost){
        if (!prepost) {
            return;
        }
        if (window.forumThread) {
            window.forumThread.replyPost(JSON.stringify(prepost));
        } else {
            prompt("replyPost", JSON.stringify(prepost));
        }
    }

    /*
     * 只看楼主
     * @param flag {number} 1为只看楼主，0为取消只看楼主
     * */
    function updateCommentHtml(flag){
//    	$(document.getElementById("postTitle")).scrollIntoView();
//    	details.commentList=[];
//    	if(flag==1){
//    		details.onlyAuthor=true
//    		details.authorId=details.article.authorId
//    		details.getCommentList(details.article.fid, details.article.tid, 1, details.pageSize, details.authorId);
//    	}
//    	else{
//    		details.onlyAuthor=false
//    		details.authorId=0
//    		details.getCommentList(details.article.fid, details.article.tid, 1, details.pageSize, details.authorId);
//    	}
    }

    /**
     * press 回调
     * @param  {[type]} img [description]
     * @return {[type]}     [description]
     */
    function pressImgCallback(img){
        if (window.forumThread) {
            window.forumThread.onImageLongPressed(img);
        } else {
            prompt("onImageLongPressed", JSON.stringify(img));
        }
    }

	/*点击头像后，前往作者详情*/
    function openAuthor(authorId) {
        // 实现native交互，跳转作者的界面
        if (window.forumThread) {
            window.forumThread.openAuthor(authorId)
        } else {
            console.log("openAuthor: " + authorId);
        }
    }
    /*点击广告后，前往广告详情*/
    function clickAds(url) {
        // 实现native交互，跳转点击广告
        if (window.forumThread) {
            window.forumThread.clickAds(url)
        } else {
            console.log("clickAds: " + url);
        }
    }
    /*举报帖子评论*/
    function report(tid,pid) {
        // 实现native交互，跳转作者的界面
        if (window.forumThread) {
            window.forumThread.report(tid,pid)
        } else {
            console.log("report: " + tid+":"+pid);
        }
    }
    /*只看楼主评论*/
    function postsOnlyUser(authorId) {
        $(document.body).scrollTop(0);
        details.commentList=[];
        details.pageIndex=1;
        if(authorId>0){
            details.currAuthorId=authorId;
            details.onlyAuthor=true;
            details.allpost=1;
            details.noMore=true;
            details.getCommentList(1,details.article.fid, details.article.tid, 1, details.pageSize, authorId);
        }
        else{
            details.currAuthorId=0;
            details.onlyAuthor=false;
            details.allpost=0;
            details.noMore=false;
            details.loadingOk=true;
            details.getCommentList(0,details.article.fid, details.article.tid, 1, details.pageSize, 0);
        }
    }
    /*跳转最新评论*/
    function gotoLatestPost() {
            details.article.replies ++
            details.pageIndex = details.pageNum;
            details.getCommentList(0,details.article.fid, details.article.tid, details.pageIndex, details.pageSize, details.authorId);
    }
     function scrollToComment() {
        document.getElementById('comment_page').scrollIntoView();
     }
     function loadMorePosts() {
        details.pageIndex++;
        if(details.onlyAuthor==true){
            details.getCommentList(1,details.article.fid, details.article.tid, details.pageIndex, details.pageSize, details.authorId);
        }else{
            details.getCommentList(0,details.article.fid, details.article.tid, details.pageIndex, details.pageSize, 0);
        }
     }
    /*
     * 关注文章作者
     * @param flag {number} 0为关注，1为取消关注
     * */
    function followAuthor(authorId,flag,tid,callback) {
        // 实现native交互，关注文章作者，返回结果（Boolean）给h5前端
        if (window.forumThread) {
            var func = $mob.ext._bindCallbackFunc(callback)
            window.forumThread.followAuthor(authorId, flag, tid,func)
        } else {
            console.log(authorId + "&&&&" + flag);
            callback(true)
        }
    }

    /*
         * 获取广告-评论区每隔5条插入一条京东广告
         * */
    function getCommentAdsList(bottom,callback) {
        if (window.forumThread) {
            var func = $mob.ext._bindCallbackFunc(callback)
            window.forumThread.getCommentAdsList(bottom,func)
        } else {
            console.log(authorId + "&&&&" + flag);
            callback(true)
        }
    }
    /*
     * 喜欢文章
     * */
    function likeArticle(fid,tid,callback) {
        // 实现native交互，喜欢文章，返回结果（Boolean）给h5前端
        if (window.forumThread) {
            var func = $mob.ext._bindCallbackFunc(callback)
            window.forumThread.likeArticle(fid, tid, func)
        } else {
            console.log(authorId + "&&&&" + flag);
            callback(true)
        }
    }

    function articleLiked(fid, tid) {
        if (window.forumThread) {
             details.article.recommend_add ++
        } else {
            console.log("article liked! fid: " + fid + " tid: " + tid);
        }
    }
   function addReply() {
        details.article.replies ++
    }
    /*界面跳转到评论模块*/
    function goComment() {
        details.goComment()
    }

    function showAddress(data) {
        if (window.forumThread) {
            window.forumThread.showAddress(JSON.stringify(data))
        } else {
            console.log("show address data : " + JSON.stringify(data))
        }
    }
    function loadArticleDay() {
        document.body.style.backgroundColor="#ffffff";
        document.body.style.color="#414141";
        document.getElementById("detail_a").style.backgroundColor="#ffffff";
        document.getElementById("detail_a").style.color="#414141";
        document.getElementById("post_content").style.backgroundColor="#f3f3f3";
        document.getElementById("post_content").style.color="#414141";
        document.getElementById("bbs-article-id").style.borderBottom="thin solid #d6d6d6";
        document.getElementById("author_top_id").style.borderBottom="thin solid #d6d6d6";
        var myul = document.getElementById("ul_ads_id");
        var myli = myul.getElementsByTagName("li");
        for (var j = 0; j < myli.length; j++) {
              myli[j].style.borderTop="thin solid #d6d6d6";
        }
    }
    function loadArticleNight() {
        document.body.style.backgroundColor="#1A1714";
        document.body.style.color="#666666";
        document.getElementById("detail_a").style.backgroundColor="#1A1714";
        document.getElementById("detail_a").style.color="#666666";
        document.getElementById("post_content").style.backgroundColor="#2e2c2c";
        document.getElementById("detail_a").style.color="#666666";
        document.getElementById("bbs-article-id").style.borderBottom="thin solid #6c6c6c";
        document.getElementById("author_top_id").style.borderBottom="thin solid #6c6c6c";
        var myul = document.getElementById("ul_ads_id");
        var myli = myul.getElementsByTagName("li");
        for (var j = 0; j < myli.length; j++) {
              myli[j].style.borderTop="thin solid #6c6c6c";
        }

    }
    function loadCommentDay() {
        document.body.style.backgroundColor="#ffffff";
        document.body.style.color="#414141";
        document.getElementById("id_reply_box").style.backgroundColor="#f3f3f3";
        document.getElementById("id_reply_box").style.color="#414141";
        var myul = document.getElementById("comm");
        var myli = myul.getElementsByTagName("li");
        for (var j = 0; j < myli.length; j++) {
              myli[j].style.borderBottom="thin solid #d6d6d6";
        }
    }
    function loadCommentNight() {
        document.body.style.backgroundColor="#1A1714";
        document.body.style.color="#666666";
        document.getElementById("id_reply_box").style.backgroundColor="#2e2c2c";
        document.getElementById("id_reply_box").style.borderLeft="2px solid #6c6c6c";
        document.getElementById("id_reply_box").style.color="#666666";
        var myul = document.getElementById("comm");
        var myli = myul.getElementsByTagName("li");
        for (var j = 0; j < myli.length; j++) {
               myli[j].style.borderBottom="thin solid #6c6c6c";
        }
    }
    function loadAdsContentDay() {
        document.body.style.backgroundColor="#ffffff";
        document.body.style.color="#414141";
        document.getElementById("div_ads_id").style.backgroundColor="#ffffff";
        document.getElementById("div_ads_id").style.color="#414141";
        var _ul = document.getElementById("ul_ads_id");
        var _li = _ul.getElementsByTagName("li");
        for (var i = 0; i < _li.length; i++) {
              _li[i].style.borderBottom="thin solid #d6d6d6";
        }

    }
    function loadAdsContentNight() {
        document.body.style.backgroundColor="#1A1714";
        document.body.style.color="#666666";
        document.getElementById("div_ads_id").style.backgroundColor="#1A1714";
        document.getElementById("div_ads_id").style.color="#666666";
        var pul = document.getElementById("ul_ads_id");
        var pli = pul.getElementsByTagName("li");
        for (var i = 0; i < pli.length; i++) {
               pli[i].style.borderBottom="thin solid #6c6c6c";
        }
    }
    /*定义BBSSDKNative全局属性*/
    window.BBSSDKNative = {
        getForumThreadDetails: getForumThreadDetails,
        getPosts: getPosts,
        openImage: openImage,
        openAttachment: openAttachment,
        openHref: openHref,
        getImageUrlsAndIndex: getImageUrlsAndIndex,
        setCurrentImageSrc: setCurrentImageSrc,
        downloadImages: downloadImages,
        showImage: showImage,
        replyComment: replyComment,
        addNewCommentHtml: addNewCommentHtml,
        pressImgCallback: pressImgCallback,
        updateCommentHtml: updateCommentHtml,
        openAuthor:openAuthor,
        clickAds:clickAds,
        getCommentAdsList:getCommentAdsList,
        report:report,
        followAuthor:followAuthor,
        likeArticle:likeArticle,
        postsOnlyUser:postsOnlyUser,
        loadMorePosts:loadMorePosts,
        addReply:addReply,
        goComment:goComment,
        gotoLatestPost:gotoLatestPost,
        scrollToComment:scrollToComment,
        articleLiked:articleLiked,
        showAddress:showAddress,
        loadArticleDay:loadArticleDay,
        loadArticleNight:loadArticleNight,
        loadCommentDay:loadCommentDay,
        loadCommentNight:loadCommentNight
    }
})();