Date.prototype.Format = function (fmt) { //author: meizz
  var o = {
    "M+": this.getMonth() + 1, //月份
    "d+": this.getDate(), //日
    "h+": this.getHours(), //小时
    "m+": this.getMinutes(), //分
    "s+": this.getSeconds(), //秒
    "q+": Math.floor((this.getMonth() + 3) / 3), //季度
    "S": this.getMilliseconds() //毫秒
  };
  if (/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
  for (var k in o)
  if (new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
  return fmt;
}
/*
 *详情页
 * */
var details=new Vue({
    el: '#details',
	data:{
		article:null,//文章详情
		commentList:[],//评论列表
		adsList:[],//广告列表
		allDataList:[],//评论广告列表
		adsCommentList:[],//评论底部广告列表
		tempList:[],//临时列表
		adsNoData:true,//没广告
		adsCommentNoData:true,//评论底部没广告
		placeholder:'写评论...',
		sendBtn:false,//发送回复按钮
		bottomAction:true,//底部三个操作图标
		popupBg:false,//弹出层背景
		popupShare:false,//分享的弹出层
		textType:1,//类型0：回复，1：评论
		commentIndex:'',//回复评论的index
		commentText:'',//回复评论的内容
		pageIndex:1,//评论当前页
		pageSize:20,//评论每页数量
		allSize:20,//评论总数量
		pageNum:1,//分页总页数
		noMore:false,//暂无更多
		isLoaded:false,//是否加载数据
		isRefresh:false,//是否刷新
		loading:false,
		loadingOk:true,
		articleLike:false,//喜欢
		onlyAuthor:false,
		authorId:0,
		currAuthorId:0,
		allpost:0,
		POITitle:'', //发帖地址
		lat:0,
		lon:0,
		styleMode:1,
		comment:0

	},

	//值发生改变触发
	watch:{

    },

    //初始化加载
	created:function(){
	    var isDragging = false
	    var _this=this
    	_this.loadingOk=true
    	document.body.addEventListener('touchstart', function () {});
        		window.onscroll  = function (){
        		    var marginBot = 0;
        		    if(_this.onlyAuthor==true){
        		    	_this.authorId=_this.article.authorId
        		    } else{
        		    	_this.authorId=0
        		    }
        		    if (document.compatMode === "CSS1Compat"){
        		        marginBot = document.documentElement.scrollHeight - (document.documentElement.scrollTop+document.body.scrollTop)-  document.documentElement.clientHeight;
        		    } else {
        		        marginBot = document.body.scrollHeight - document.body.scrollTop-  document.body.clientHeight;
        		    }
        		    if(marginBot<=0 && _this.loadingOk==true ) {
            			_this.loadingOk=false
        		    	if(_this.noMore==true ){
            				return
            			}
        		    	setTimeout(function(){
        		        	_this.loading=true
        		        	setTimeout(function(){
        			        	_this.loading=false
        			        	_this.loadingOk=true
        			        	_this.pageIndex++
        			        	_this.getCommentList(_this.allpost,_this.article.fid, _this.article.tid, _this.pageIndex, _this.pageSize, _this.currAuthorId)
        			        },1000)
        		        },100)
        		    }
        		}
		BBSSDKNative.getForumThreadDetails(function(detailData) {
			detailData=JSON.parse(detailData)
			_this.styleMode = detailData.mode;
			_this.comment = detailData.comment;
			_this.getArticle(detailData)
			// 页面初始化完成，获取主题帖子列表getCommonHtml(page, detailData.fid, detailData.tid, detailData.authorId);
			_this.getCommentList(0,detailData.fid, detailData.tid, _this.pageIndex, _this.pageSize, _this.authorId)
		});

		this.$nextTick(function () {
			$(document).on("click", ".article-text a", function(e){
				e.preventDefault();
				BBSSDKNative.openHref($(this).attr("href"));
			})
			$(document).on("click", ".comment-text a", function(e){
                e.preventDefault();
                BBSSDKNative.openHref($(this).attr("href"));
            })
			$(document).on("click", ".article-text img[src_flag='0']", function(e){
				var imgList=[]
				var md=$(this).attr("src_tag")
				var n=-1
				var i=''
				$(".article-text img[src_flag='0']").each(function(){
					n++
					if($(this).attr("smilieid")){
						return true
					}
				    imgList.push($(this).attr("src_link"))
				    if(md==$(this).attr("src_tag")){
				    	i=n
				    }
				})
				BBSSDKNative.openImage(imgList,i);
			})

			$(document).on("click", ".comment img[src_flag='0']", function(e){
                var imgList=[]
                var md=$(this).attr("src_tag")
                var n=-1
                var i=''
                $(".comment img[src_flag='0']").each(function(){
                    n++
                    if($(this).attr("smilieid")){
                        return true
                    }
                    imgList.push($(this).attr("src_link"))
                    if(md==$(this).attr("src_tag")){
                        i=n
                    }
                })
                BBSSDKNative.openImage(imgList,i);
            })
		})
    },
    methods:{
    	/*获得文章详情*/
    	getArticle: function(detailData){
    		var _this=this
    		var imgList=[]
    		var count;
    		_this.article=detailData
    		_this.$nextTick(function () {
				$(".article-text img").each(function(){
				    $(this).attr("src_link",$(this).attr("src"))
				    $(this).attr("src_tag",md5($(this).attr("src_link")))
				    $(this).addClass(md5($(this).attr("src_link")))
				    var attr_id = $(this).attr('id');
				    if(typeof attr_id != typeof undefined && attr_id != false){
				        $(this).attr("src_flag",'0')
				    }else{
				        $(this).attr("src_flag",'1')
				    }
				    $(this).attr("srcset",'')
				    imgList.push($(this).attr("src_link"))
				})
				$(".article-text iframe").each(function(){
                    $(this).attr("height",'300')
                    $(this).attr("width",'100%')
                })
			    if(_this.styleMode==1){
			        BBSSDKNative.loadArticleNight()
                }else{
                    BBSSDKNative.loadArticleDay()
                }
                if(_this.comment==1){
                    BBSSDKNative.goComment()
                }
			})
    	},
    	/*获得评论列表详情*/
    	getCommentList: function(all,fid, tid, page, pageSize,authorId){
    		var _this=this
    		var imgList=[]
    		BBSSDKNative.getPosts(all,fid, tid, page, pageSize, authorId, function(list) {
                if(list==null){
                    _this.noMore=true
                    return
                }
                if( list.length<_this.pageSize-1){
                    _this.noMore=true
                }
                //_this.tempList=[];
                for(var i=0; i<list.length; i++){
                    _this.commentList.push(list[i])
                    //_this.tempList.push(list[i])
                }
                _this.$nextTick(function () {
                    $(".comment img").each(function(){
                        $(this).attr("src_link",$(this).attr("src"))
                        $(this).attr("src_tag",md5($(this).attr("src_link")))
                        $(this).addClass(md5($(this).attr("src_link")))
                        var img_id = $(this).attr('id');
                        if(typeof img_id != typeof undefined && img_id != false){
                            $(this).attr("src_flag",'0')
                        }else{
                            $(this).attr("src_flag",'1')
                        }
                        $(this).attr("srcset",'')
                        imgList.push($(this).attr("src_link"))
                    })
                    $(".ads_img img").each(function(){
                        $(this).attr("src_flag",'1')
                    })
                })
            });
			if(_this.styleMode==1){
            	BBSSDKNative.loadCommentNight()
            }else{
                BBSSDKNative.loadCommentDay()
            }
            //_this.getCommentAdsList()
    	},

    	/*每隔5条评论插一条广告*/
    	getCommentAdsList: function(){
            var _this=this
            BBSSDKNative.getCommentAdsList(0,function(list) {
                if(list!=null ){
                    _this.adsNoData=false;
                    if(_this.tempList.length>0){
                        var x=0;
                        var y=0;
                        var z=0;
                        if(_this.tempList.length<=6){
                            y=1;
                        }else{
                            y = Math.ceil(_this.tempList.length / 6);
                            z = y-1;
                        }
                        for(var i=0; i<y; i++){
                            if(i==0 && y==1){
                                x = _this.tempList.length;
                            }else if(i<z){
                                x=(i+1)*5+i;
                            }else if(i==z){
                                x = 6*y;
                                if(x>_this.tempList.length){
                                    x = _this.tempList.length;
                                }
                            }
                            if(i>=list.length){
                                break;
                            }else{
                                _this.tempList.splice(x,0,list[i]);
                            }
                        }
                        for(var i=0; i<_this.tempList.length; i++){
                            _this.allDataList.push(_this.tempList[i]);
                        }
                        _this.tempList=[];
                    }else{
                       for(var i=0; i<_this.commentList.length; i++){
                           _this.allDataList.push(_this.commentList[i])
                       }
                    }
                }else{
                    _this.adsNoData=true;
                    _this.allDataList=[];
                    for(var i=0; i<_this.commentList.length; i++){
                        _this.allDataList.push(_this.commentList[i])
                    }
                }
            });
         },
          /*评论底部广告*/
         getAdsCommentList: function(){
              var _this=this
              BBSSDKNative.getCommentAdsList(1,function(list) {
                  if(list!=null ){
                      _this.adsCommentNoData=false;
                      if(_this.adsCommentList.length==0){
                         for(var i=0; i<list.length; i++){
                             _this.adsCommentList.push(list[i]);
                         }
                      }
                  }else{
                      _this.adsCommentNoData=true;
                  }
              });
           },
    	/*关注*/
    	follow: function(authorId,follow,tid){
    		var _this=this
    		if(follow==0){
    			BBSSDKNative.followAuthor(authorId,0,tid,function(result) {
    				if(result==true){
		    			_this.article.follow=1
		    		}
				});
    		}
    		else{
    			BBSSDKNative.followAuthor(authorId,1,tid,function(result) {
	    			if(result==true){
		    			_this.article.follow=0
		    		}
				});
    		}
    	},
    	/*喜欢likeArticle*/
    	like: function(fid,tid){
    		var _this=this
    		if(_this.articleLike==false){
    			BBSSDKNative.likeArticle(fid,tid,function(result) {
	    			if(result==true){
		    			_this.articleLike=true
		    			_this.article.recommend_add++
		    		}
				});
    		}
    	},
    	/*前往作者详情*/
    	openAuthor: function(authorId){
    		BBSSDKNative.openAuthor(authorId)
    	},
    	clickAds: function(url){
            BBSSDKNative.clickAds(url)
        },
    	/*举报帖子评论*/
        report: function(tid,pid){
            BBSSDKNative.report(tid,pid)
        },
    	/*只看个人评论或全部评论*/
        postsOnlyUser: function(authorId){
            BBSSDKNative.postsOnlyUser(authorId)
        },
        loadMorePost: function(){
            BBSSDKNative.loadMorePosts()
        },
    	/*附件*/
    	openAttachment: function(data){
    		BBSSDKNative.openAttachment(data)
    	},
    	//回复
    	reply: function(data){
    		BBSSDKNative.replyComment(data)
    	},
    	openAddress: function(data) {
    	    BBSSDKNative.showAddress(data)
    	},
    	timeSet: function(time){
    	    var date = new Date(time*1000);
    	    var timeYear = date.getFullYear();
    	    var date1 = new Date();
    	    var dateYear =date1.getFullYear();
	        var diffdate = new Date().getTime() - time*1000;
	        var days = Math.floor(diffdate/(24*3600*1000));
	        var leave1 = diffdate%(24*3600*1000);
	        var hours = Math.floor(leave1/(3600*1000));
	        var leave2 = leave1%(3600*1000);
	        var minutes = Math.floor(leave2/(60*1000));
	        var leave3 = leave2%(60*1000);
	        var seconds = Math.round(leave3/1000);
            var thedate = new Date(time * 1000).Format("MM-dd hh:mm");
            var thedate1 = new Date(time * 1000).Format("yyyy-MM-dd hh:mm");
	        return (timeYear && timeYear<dateYear) ? thedate1 : (days && days > 0) ? thedate : (hours && hours > 0) ? hours + "小时前" : (minutes && minutes > 0) ? minutes + "分钟前" : "刚刚";
	    },
	    goComment: function(){
	    	var _this=this
	    	setTimeout(function(){
		    	_this.$nextTick(function () {
		    		window.location.href="#postTitle"
		    	})
		    },100)
	    }
    }
})